uses dos;

{$M $4000,0,0 }   { kvuli execu }

const reseni = 'vlak.exe';
      report = 'report.txt';

type t_vlak = record
                n : integer;
                vahy : array[1 .. 100] of integer;
              end;

var
    { zadani }
    vagony : t_vlak;
    k : integer; { pocet vagonu na oblouku }
    m : integer; { nostnost oblouku }

    cur_dir : string; { aktualni adresar }
    ven : text;

procedure error(msg : string);
begin
  writeln('Chyba: ', msg);
  halt(1);
end;

procedure setrid_vlak(var v : t_vlak);
var i, j : integer;
    min, pom : integer;
begin
  with v do
    begin
      for i := 1 to n - 1 do
        begin

          { hledani minima }
          min := i;
          for j := i + 1 to n do
              if vahy[min] > vahy[j] then min := j;

          { prohodime vahy[i], vahy[min] }
          pom := vahy[i];
          vahy[i] := vahy[min];
          vahy[min] := pom;
        end;
    end;
end;


{ prekopiruje jeden textovy soubor do druheho }
procedure kopiruj(src, dst : string);
var s, d : text;
    radek : string;
begin
  assign(s, src);
  {$I-}
  reset(s);
  {$I+}
  if IOResult <> 0 then
    error('Nemohu otevrit soubor "' + src + '" pro cteni.');

  assign(d, dst);
  {$I-}
  rewrite(d);
  {$I+}
  if IOResult <> 0 then
    error('Nemohu otevrit soubor "' + dst + '" pro zapis.');

  while not eof(s) do
    begin
      {$I-}
      readln(s, radek);
      if IOResult <> 0 then
        error('Nemohu cist ze souboru "' + src + '".');

      writeln(d, radek);
      if IOResult <> 0 then
        error('Nemohu zapisovat do souboru "' + dst + '".');
      {$I+}
    end;

  close(s);
  close(d);
end;


procedure smaz(filename : string);
var f : file;
begin
  assign(f, filename);
  {$I-}
  erase(f);
  {$I+}
  if IOResult <> 0 then
    error('Nemohu smazat soubor "' + filename + '".');
end;


function existuje(filename : string) : boolean;
var f : file;
begin
  assign(f, filename);
  {$I-}
  reset(f);
  {$I+}
  if IOResult = 0 then
    begin
      existuje := true;
      close(f);
    end
  else
    existuje := false;
end;


procedure nacti_zadani;
var f : text;
begin
  assign(f, 'vstup.txt');
  {$I-}
  reset(f);
  {$I+}
  if IOResult <> 0 then
     error('Nemohu otevrit soubor "vstup.txt" pro cteni.');

  vagony.n := 0;
  while not eoln(f) do with vagony do
    begin
      n := n + 1;
      read(f, vahy[n]);
    end;
  readln(f);
  read(f, k, m);

  close(f);
end;


function upstring(s : string) : string;
var i : integer;
begin
  for i := 1 to length(s) do s[i] := upcase(s[i]);
  upstring := s;
end;


procedure nacti_reseni(filename : string; var reseni : t_vlak);
var f : text;
    s : string;
    i, j, c : integer;
begin
  assign(f, filename);
  {$I-}
  reset(f);
  {$I+}
  if IOResult <> 0 then
    error('Nemohu otevrit soubor "' + filename + '" pro cteni.');
  {$I-}
  readln(f, s);
  {$I+}
  if IOResult <> 0 then
    error('Nemohu cist ze souboru "' + filename + '".');
  close(f);

  if upstring(s) = 'NELZE' then
    reseni.n := -1
  else
    begin
      reseni.n := 0;
      i := 1;
      while i <= length(s) do
        begin
          { preskocime nenumericke znaky }
          while (i <= length(s)) and not (s[i] in ['0' .. '9']) do
            i := i + 1;
          { najdeme konec cisla }
          j := i;
          while (j <= length(s)) and (s[j] in ['0' .. '9']) do j := j + 1;

          { i je ted na prvnim znaku cisla,
            j je na prvnim znaku za cislem }
          if i < j then with reseni do
            begin
              n := n + 1;
              val(copy(s, i, j - i), vahy[n], c);
              if c <> 0 then
                error('Chyba ve formatu souboru "' + filename + '".');
            end;
          i := j;
        end;
    end;
end;


function spravne(vzor : string) : boolean;
var f : text;
    s : string;
    l : boolean;
    ok, reseni : t_vlak;
    suma, i : integer;
begin
  nacti_zadani;
  setrid_vlak(vagony); { setridi vagony ze zadani }

  nacti_reseni(vzor, ok); { nacte vzorove reseni }
  nacti_reseni('vystup.txt', reseni); { nacte reseni testovaneho programu }

  if ok.n = -1 then
    begin
       spravne := reseni.n = -1;
       exit;
    end;
  spravne := false;
  { vagonu by mel byt stejny pocet }
  if reseni.n <> vagony.n then exit;

  { test na nosnost oblouku }
  suma := 0; { soucet poslednich k vagonu }
  for i := 1 to k - 1 do suma := suma + reseni.vahy[i];
  i := k;
  while i <= vagony.n do
    begin
      suma := suma + reseni.vahy[i];
      if suma > m then exit;
      i := i + 1;
      suma := suma - reseni.vahy[i - k];
    end;

  { test zda jsou vahy opravdu permutaci }
  setrid_vlak(reseni);
  for i := 1 to reseni.n do if vagony.vahy[i] <> reseni.vahy[i] then exit;

  spravne := true;
end;


function test(vstup, vzor : string) : boolean;
begin
  kopiruj(vstup, 'vstup.txt');

  swapvectors;
  exec('.\' + reseni, '');
  swapvectors;
  if doserror <> 0 then error('Nemohu spustit program .\'
                        + reseni + '.');
  test := spravne(vzor);
end;

procedure projdi_adresare;
var dir_info : SearchRec;
    r : boolean;
begin
  findfirst('*.*', Directory, dir_info);

  while DosError = 0 do with dir_info do
    begin
      if (attr = Directory) and (name <> '.') and (name <> '..') then
        begin
          {$I-}
          write(ven, name, ' ... ');
          {$I+}
          if IOResult <> 0 then
            error('Chyba pri zapisu do souboru "' + report + '".');

          write(name, ' ... ');

          r := test(name + '\vstup.txt', name + '\vystup.txt');
          if r then
            begin
              {$I-}
              writeln(ven, 'Ok.');
              {$I+}
              if IOResult <> 0 then
                error('Chyba pri zapisu do souboru "' + report + '".');

              writeln('Ok.');
            end
          else
            begin
              {$I-}
              writeln(ven, 'Chybny vystup.');
              {$I+}
              if IOResult <> 0 then
                error('Chyba pri zapisu do souboru "' + report + '".');

              writeln('Chybny vystup.');
            end;
        end;
      findnext(dir_info);
    end;
end;


begin
  if existuje('vstup.txt') then error('Soubor "vstup.txt" jiz existuje.');
  if existuje('vystup.txt') then error('Soubor "vystup.txt" jiz existuje.');
  assign(ven, report);
  {$I-}
  rewrite(ven);
  {$I+}
  if IOResult <> 0 then
    error('Chyba pri otevirani souboru "' + report + '" pro zapis.');

  projdi_adresare;
  close(ven);
  smaz('vstup.txt');
  smaz('vystup.txt');
end.